# import pickle
# import pymongo
# import bson
# import warnings

# from datetime import datetime

import tempfile
import unittest
from mongoengine import *

import pymongo, gridfs

class BugFixTest(unittest.TestCase):


    def setUp(self):
        conn = connect(db='mongoenginetest')

    def test_example(self):

        class GridDocument(Document):
            the_file = FileField()

        GridDocument.drop_collection()

        with tempfile.TemporaryFile() as f:
            f.write("Hello World!")
            f.flush()

            # Test without default
            doc_a = GridDocument()
            doc_a.save()


            doc_b = GridDocument.objects.with_id(doc_a.id)
            doc_b.the_file.replace(f, filename='doc_b')
            doc_b.save()
            self.assertNotEquals(doc_b.the_file.grid_id, None)

            # Test it matches
            doc_c = GridDocument.objects.with_id(doc_b.id)
            self.assertEquals(doc_b.the_file.grid_id, doc_c.the_file.grid_id)

            # Test with default
            doc_d = GridDocument(the_file='')
            doc_d.save()

            doc_e = GridDocument.objects.with_id(doc_d.id)
            self.assertEquals(doc_d.the_file.grid_id, doc_e.the_file.grid_id)

            doc_e.the_file.replace(f, filename='doc_e')
            doc_e.save()

            doc_f = GridDocument.objects.with_id(doc_e.id)
            self.assertEquals(doc_e.the_file.grid_id, doc_f.the_file.grid_id)

        db = GridDocument._get_db()
        grid_fs = gridfs.GridFS(db)
        self.assertEquals(['doc_b', 'doc_e'], grid_fs.list())

